ATK_INTER
#ifndef _phlumph_H_
#define _phlumph_H_

/*
	Copyright Carnegie Mellon University 1994 - All rights reserved
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
 * 
 * Permission to use, copy, modify, and distribute this software for any 
 * purpose is hereby granted, provided (a) that no fee is charged for the 
 * software, for the medium on which it is distributed, for the 
 * distribution process, or for effort involved in making the distribution;  
 * (b) that all copyright notices, this permission notice, and the 
 * following disclaimer remain in these files and appear in supporting 
 * documentation;  (c) that you do not translate, reverse engineer, 
 * decompile, or disassemble the software; and (d) that the names of 
 * IBM, Carnegie Mellon University, and other copyright holders not 
 * be used in advertising or publicity pertaining to distribution of the 
 * software.
 * 
 * CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
 * COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
 * WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
 * UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
 * OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE.
 *  $

  $Header: /afs/cs/user/rr2b/7.4/src/RCS/phlumph.H,v 1.1 1995/03/23 21:09:49 Zarf Stab74 $
*/
#include <dataobject.H>

#define phlumph_AtEnd (-1)
#define phlumph_DatastreamVersion (1)
#define phlumph_DATACHANGED 1
#define phlumph_PAGESCHANGED 2

class phlumph : public dataobject {
  public:
    virtual ATKregistryEntry *ATKregistry();

    phlumph();
    virtual ~phlumph();

    char *ViewName();
    long Write(FILE *fp, long writeid, int level);
    long Read(FILE *file, long id);

    virtual boolean InsertPage(int where);
    virtual void DeletePage(int num);
    virtual void SetRepeat(int num);

    int numpages;
    class textflow **pagelist;
    int listsize;
    int repeat;

    inline int GetRepeat() { return this->repeat; };
    inline int GetNumPages() { return this->numpages; };
    inline class textflow *GetPage(int num) {
	if (num < 0 || num >= this->numpages || !this->pagelist)
	    return NULL;
	else
	    return this->pagelist[num];
    };
};

#endif /* _phlumph_H_ */
